import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.Scanner;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.HashMap;
import java.awt.Point;
import javax.swing.JOptionPane;

/**
 * Write a description of class Screen here.
 * 
 * @author Taylor Born
 * @version October 2011
 */
public class Screen extends World
{
    private ListBox list = new ListBox(new Point(275, 250), new ArrayList<String>());
    private TextBox txtB = new TextBox(new Point(275, 250), getInitialText());
    private Menu menu = new Menu(new ArrayList<String>(){{ add("TextBox"); add("ListBox"); }} );
    
    public Screen()
    {
        super(600, 400, 1);
        addObject(list, 138, 265);
        addObject(txtB, 461, 265);
        menu.addItems("TextBox/", new ArrayList<String>(){{ add("Load Text"); add("Set Text"); add("Print"); add("Clear"); }} );
        menu.addItems("TextBox/Load Text/", new ArrayList<String>(){{ add("Bricklayer"); add("Preamble"); }} );
        menu.addItems("ListBox/", new ArrayList<String>(){{ add("Calculate"); add("Print"); }} );
        addObject(menu, 300, 6);
    }
    public void act()
    {
        String item = menu.getItemPressed();
        if (item != null)
        {
            if (item.startsWith("TextBox/Load Text/"))
            {
                item = item.substring(item.indexOf("/") + 1);
                item = item.substring(item.indexOf("/") + 1);
                String source = item.substring(0, item.indexOf("/"));
                txtB.setText("");
                try
                {
                    BufferedReader br = new BufferedReader(new InputStreamReader(getClass().getClassLoader().getResource(source + ".txt").openStream()));
                    String str = br.readLine();
                    while (str != null)
                    {
                        txtB.setText(txtB.getText() + (txtB.getText().length() == 0 ? str : "\n" + str));
                        str = br.readLine();
                    }
                    br.close();
                }
                catch (IOException ex)
                {
                    System.err.println(ex.getMessage());
                }
            }
            else if (item.equals("TextBox/Set Text/"))
            {
                String str = JOptionPane.showInputDialog(null, "New Text:");
                if (str != null)
                    txtB.setText(str);
            }
            else if (item.equals("TextBox/Print/"))
            {
                System.out.println(txtB.getText());
                System.out.println("");
            }
            else if (item.equals("TextBox/Clear/"))
                txtB.setText("");
            else if (item.equals("ListBox/Calculate/"))
                updateListBox();
            else if (item.equals("ListBox/Print/"))
            {
                for (String s : list.getList())
                    System.out.println(s);
                System.out.println("");
            }
        }
        if (txtB.hasChanged())
        {
            //updateListBox();
            list.clear();
        }
    }
    public void updateListBox()
    {
        list.clear();
        
        HashMap<String, Integer> hm = new HashMap<String, Integer>();
        
        int total = 0;
        
        StringTokenizer st = new StringTokenizer(txtB.getText().toLowerCase(), " ,?!;:\".\n0123456789()*&^%$#@+=");
        
        while (st.hasMoreElements())
        {
            total++;
            String s = (String)st.nextElement();
            Integer i = hm.get(s);
            if (i == null)
                hm.put(s, 1);
            else
                hm.put(s, i + 1);
        }
        
        int totalUnique = 0;
        
        CountNode first = null;
        
        for (String s : hm.keySet())
        {
            int n = hm.get(s);
            
            if (first == null)
                first = new CountNode(s, n);
            else if (first.getCount() <= n)
                first = new CountNode(s, n, first);
            else
            {
                CountNode cn = first;
                while (cn.getNext() != null && cn.getNext().getCount() > n)
                    cn = cn.getNext();
                cn.setNext(new CountNode(s, n, cn.getNext()));
            }
            totalUnique++;
        }
        
        list.addString("TOTAL WORD COUNT: " + total);
        list.addString("UNIQUE WORDS: " + totalUnique);
        list.addString("");
        
        CountNode cn = first;
        while (cn != null)
        {
            list.addString(cn.getString() + "   " + cn.getCount());
            cn = cn.getNext();
        }
        list.scrollToTop();
    }
    public String getInitialText()
    {
        String s = "";
        try
        {
            BufferedReader br = new BufferedReader(new InputStreamReader(getClass().getClassLoader().getResource("Bricklayer.txt").openStream()));
            String str = br.readLine();
            while (str != null)
            {
                s += (s.length() == 0 ? str : "\n" + str);
                str = br.readLine();
            }
            br.close();
        }
        catch (IOException ex)
        {
            System.err.println(ex.getMessage());
        }
        return s;
    }
}